#include<iostream>
#include<cstdlib>
#include<ctime>
#include<string.h>
#include<string>
#include<stdio.h>
#include<iomanip>
#include<fstream>
#include<conio.h>
#include <SFML/Window.hpp>
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>
using namespace std;

class account
{
	int acno;
	char name[50];
	int deposit;
	char pass[20];
public:
	void create_account();	//function to get data from player
	void show_account(); 	//function to show data on screen
	void modify(); //function to add new data
	void modify_pass(char[]);	//function to modify password
	void dep(int);	//function to accept amount and add to balance amount
	void draw(int);	//function to accept amount and subtract from balance amount
	void report(); 	//function to show data in tabular format
	int retacno(); //function to return account number
	int retdeposit(); 	//function to return balance amount
	int checkpass(char[]); //function to verify password

};         //class ends here

void account::create_account()
{
	cout<<"\nEnter The account No. :";
	cin>>acno;
	cout<<"\nEnter The Name of The account Holder : ";
	cin>>name;
	cout<<"\nEnter account password : ";
	cin>>pass;
	cout<<"\nEnter The Initial amount: ";
	cin>>deposit;
	cout<<"\nAccount Created..";
}

void account::show_account()
{
	cout<<"\n\nAccount No. : "<<acno;
	cout<<"\nAccount Holder Name : ";
	cout<<name;
	cout<<"\nBalance amount : "<<deposit;
}


void account::modify()
{
	cout<<"\nAccount No. : "<<acno;
	cout<<"\nModify Account Holder Name : ";
	cin>>name;
	cout<<"\nModify Password : ";
	cin>>pass;
	cout<<"\nModify Balance amount : ";
	cin>>deposit;
}

void account::modify_pass(char pass1[20])
{
    strcpy(pass,pass1);
    return;
}

void account::dep(int x)
{
	deposit+=x;
}

void account::draw(int x)
{
	deposit-=x;
}

void account::report()
{
	cout<<acno<<setw(10)<<" "<<name<<setw(10)<<" "<<pass<<setw(15)<<deposit<<endl;
}


int account::retacno()
{
	return acno;
}

int account::retdeposit()
{
	return deposit;
}

int account::checkpass(char pass1[20])
{
    if(strcmp(pass,pass1)==0)
    {
        return 1;
    }
    else return 0;
}

//***************************************************************
//    	function declaration
//****************************************************************
void write_account();	//function to write record in binary file
void display_sp(int);	//function to display account details given by user
void modify_account(int);	//function to modify record of file
void modify_account_pass(char[]);//function to modify account password
void delete_account(int);	//function to delete record of file
void display_all();		//function to display all account details
void deposit(int); // function to desposit amount for given account
void deposit_win(int,int);
int withdraw(int); // function to withdraw amount for given account

//***************************************************************
//    	function to write in file
//****************************************************************

void write_account()
{
	account ac;
	ofstream outFile;
	outFile.open("account.dat",ios::binary|ios::app);
	ac.create_account();
	outFile.write((char *)&ac, sizeof(account));
	outFile.close();
}

//***************************************************************
//    	function to read specific record from file
//****************************************************************

void display_sp(int n)
{
	account ac;
	bool flag=false;
	ifstream inFile;
	inFile.open("account.dat",ios::binary);
	if(!inFile)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	cout<<"\nBALANCE DETAILS\n";

    	while(inFile.read((char *)&ac, sizeof(account)))
	{
		if(ac.retacno()==n)
		{
			ac.show_account();
			flag=true;
		}
	}
	inFile.close();
	if(flag==false)
		cout<<"\n\nAccount number does not exist";
}


//***************************************************************
//    	function to modify record of file
//****************************************************************

void modify_account(int n)
{
	bool found=false;
	account ac;
	fstream File;
	File.open("account.dat",ios::binary|ios::in|ios::out);
	if(!File)
	{
		cout<<"No account records exist!! Press any Key...";
		return;
	}
	while(!File.eof() && found==false)
	{
		File.read((char* )&ac, sizeof(account));
		if(ac.retacno()==n)
		{
			ac.show_account();
			cout<<"\n\nEnter The New Details of account"<<endl;
			ac.modify();
			int pos=(-1)*(sizeof(account));
			File.seekp(pos,ios::cur);
			File.write((char *)&ac, sizeof(account));
			cout<<"\n\n\t Record Updated";
			found=true;
		  }
	}
	File.close();
	if(found==false)
		cout<<"\n\n Record Not Found ";
}

//***************************************************************
//    	function to modify account password
//****************************************************************

void modify_account_pass(int n)
{char pass[20]; account ac;
cout<<"\nEnter new password: ";
cin>>pass;
fstream File;
	File.open("account.dat",ios::binary|ios::in|ios::out);
	if(!File)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	File.seekp(0,ios::beg);
	while(!File.eof())
	{
		File.read((char* )&ac, sizeof(account));
		if(ac.retacno()==n)
		{
			ac.modify_pass(pass);
			int pos=(-1)*(sizeof(account));
			File.seekp(pos,ios::cur);
			File.write((char *)&ac, sizeof(account));
			cout<<"\n\t Password Updated\n";
			break;
		  }
	}
	File.close();

}

//***************************************************************
//    	function to delete record of file
//****************************************************************


void delete_account(int n)
{
	account ac;
	ifstream inFile;
	ofstream outFile;
	inFile.open("account.dat",ios::binary);
	if(!inFile)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	outFile.open("Temp.dat",ios::binary);
	inFile.seekg(0,ios::beg);
	while(inFile.read((char* )&ac, sizeof(account)))
	{
		if(ac.retacno()!=n)
		{
			outFile.write((char *)&ac, sizeof(account));
		}
	}
	inFile.close();
	outFile.close();
	remove("account.dat");
	rename("Temp.dat","account.dat");
	cout<<"\n\n\tUser Account Removed successfully ..";
}

//***************************************************************
//    	function to display all accounts deposit list
//****************************************************************

void display_all()
{
	account ac;
	ifstream inFile;
	inFile.open("account.dat",ios::binary);
	if(!inFile)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	cout<<"\n\n\t\tACCOUNT HOLDER LIST\n\n";
	cout<<"====================================================\n";
	cout<<"A/c no.      NAME           Password          Balance\n";
	cout<<"====================================================\n";
	while(inFile.read((char *)&ac, sizeof(account)))
	{
		ac.report();
	}
	inFile.close();
}

//***************************************************************
//    	functions to deposit and withdraw amounts
//****************************************************************

void deposit(int n)
{
	int amt;
	bool found=false;
	account ac;
	fstream File;
	File.open("account.dat", ios::binary|ios::in|ios::out);
	if(!File)
	{
		cout<<"No account records exist!";
		return;
	}
	while(!File.eof() && found==false)
	{
		File.read((char *)&ac, sizeof(account));
		if(ac.retacno()==n)
		{
			ac.show_account();
            cout<<"\n\nEnter The amount to be deposited: ";
            cin>>amt;
            ac.dep(amt);
			int pos=(-1)*(sizeof(ac));
			File.seekp(pos,ios::cur);
			File.write((char *)&ac, sizeof(account));
			cout<<"\n\n\t Record Updated";
			found=true;
	       }
         }
	File.close();
	if(found==false)
		cout<<"\n\n Record Not Found ";
}

int withdraw(int n)
{
	int amt;
	bool found=false;
	account ac;
	fstream File;
	File.open("account.dat", ios::binary|ios::in|ios::out);
	if(!File)
	{
		cout<<"File could not be open !! Press any Key...";
		return 0;
	}
	while(!File.eof() && found==false)
	{
		File.read((char *)&ac, sizeof(account));
		if(ac.retacno()==n)
		{
			ac.show_account();
            cout<<"\nEnter bet AMOUNT(minimum 100): ";
            cin>>amt;
            if(amt<100){cout<<"\nMinimum bet is 100 points!!\n";return -1;}
            int bal=ac.retdeposit()-amt;
            if(bal<0)
            {cout<<"\nInsufficient balance in player's account\n"; return -1;}
            else
            {ac.draw(amt);
			int pos=(-1)*(sizeof(ac));
			File.seekp(pos,ios::cur);
			File.write((char *)&ac, sizeof(account));
			cout<<"\nBet amount withdrawn from the account!";
			found=true;
             }
		}
	}
	File.close();
	if(found==false)
    cout<<"\n\n Record Not Found ";
    return amt;
}


void deposit_win(int amt,int n)
{
	bool found=false;
	account ac;
	fstream File1;
	File1.open("account.dat", ios::binary|ios::in|ios::out);
	if(!File1)
	{
		cout<<"No account records exist!";
		return;
	}
	while(!File1.eof() && found==false)
	{
		File1.read((char *)&ac, sizeof(account));
		if(ac.retacno()==n)
		{
            ac.dep(amt);
			int pos=(-1)*(sizeof(ac));
			File1.seekp(pos,ios::cur);
			File1.write((char *)&ac, sizeof(account));
			found=true;
	       }
         }
	File1.close();
	if(found==false)
		cout<<"\n\n Record Not Found ";
}

//-----------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------
//CODE PART 1 ENDS HERE(The data file handling part)
//-----------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------

class Game
{
public:
        void init_array();
        int init_level();
        void run();
        Game(account a)
        {
            ac=a;check=1;check1=0;
        }


private:
        int m,nr,nc,n,x,y,row,column,check,check1,bet; account ac;
        int a[10][10],print[10][10],flag[10][10],n_mines[10][10];
        void processEvents();
        void render();
        void get_location();
        int uncover();
        void flagit();
        void unflagit();
        int check_win();
private:
        sf::RenderWindow mWindow;
};

int Game::init_level()
{
    cout<<"\nWhich level do you want to play?\n"<<endl<<"\n1.Beginner(5*5,4 mines)[pays 2*BET AMOUNT] (enter no.1)\n"<<endl<<"2.Medium(7*7,9 mines) [pays 3*BET AMOUNT](enter no.2)\n"<<endl<<"3.Expert(9*9,15 mines) [pays 4*BET AMOUNT](enter no.3)"<<endl;
         cout<<"\n\nplease give your choice:  ";
         cin>>m;
         if((m!=1)&&(m!=2)&&(m!=3))
         {
          cout<<"invalid input";

         }

         switch(m)
         {
            case 1: nr=5;nc=5;n=4;break;
            case 2: nr=7;nc=7;n=9;break;
            case 3: nr=9;nc=9;n=15;break;

        }
        bet=withdraw(ac.retacno());
        if(bet<0)
        {
            return -1;
        }
        else return 1;

}

int validate(int row,int column,int r,int c)
{
    if((row>r)||(row<0)||(column>c)||(column<0))
    {
        return -1;
    }
    return 1;
}
void uncover1(int a[][10],int flag[][10],int print[][10],int n_mines[][10],int row,int column,int r,int c,int check[10][10])
{
    int i;
    i=validate(row,column,r,c);
    if(i!=1){return ;}
    print[row][column]=1;
    check[row][column]=1;
    if(n_mines[row][column]==0)
    {

        for(int i=-1;i<2;i++)
        {
            for(int j=-1;j<2;j++)
            {
                if(check[row+i][column+j]==0)uncover1(a,flag,print,n_mines,row+i,column+j,r,c,check);
            }
        }

    }
    return ;
}

int Game::uncover()
{
    int check[10][10];
    if(n_mines[row][column]==-1)
    {
        return -1;
    }
    for(int i=0;i<nr;i++)
    {
        for(int j=0;j<nc;j++)
        {
            check[i][j]=0;
        }
    }
    uncover1(a,flag,print,n_mines,row,column,nr,nc,check);
    return 1;
}

void Game::flagit()
{
    if((a[row][column]==1)&&(flag[row][column]==0)&&(print[row][column]==0))
    {flag[row][column]=1;
     return;
    }
    if((a[row][column]==0)&&(flag[row][column]==0)&&(print[row][column]==0))
    {flag[row][column]=1;
     return;
    }
}
void Game::unflagit()
{
    if((a[row][column]==1)&&(flag[row][column]==1)&&(print[row][column]==1))
    {flag[row][column]=0;
     return;
    }
    if((a[row][column]==1)&&(flag[row][column]==1)&&(print[row][column]==0))
    {flag[row][column]=0;
     return;
    }
    if((a[row][column]==0)&&(flag[row][column]==1)&&(print[row][column]==1))
    {   print[row][column]==0;
        flag[row][column]=0;
        return;
    }
    if((a[row][column]==0)&&(flag[row][column]==1)&&(print[row][column]==0))
    {flag[row][column]=0;
     return;
    }
}


void Game::init_array()
{
int i,j,k,p,q,s,count;
for(i=0;i<10;i++) // initialize the three declared arrays to 0
{
  for(j=0;j<10;j++)
  {
      a[i][j]=0;
       print[i][j]=0;
        flag[i][j]=0;
  }
}
srand(time(0));
 // place the mines in the grid randomly
{for(k=0;k!=n;i=0,j=0)
{
    i=(rand()%nr);
    j=(rand()%nc);

    if(a[i][j]!=1)
    {
        a[i][j]=1;
        k++;
    }

}

}

for(i=0;i<nr;i++)  // initialize n_mines with no. of mines surrounding each square
{
    for(j=0;j<nc;j++)
    {count=0;
        if(a[i][j]==0)
        {
            for(p=i-1;p<i+2;p++)
            {
                for(q=j-1;q<j+2;q++)
                {
                    s=validate(p,q,nr-1,nc-1);
                    if(s==1)
                    {
                        if(a[p][q]==1)
                        {
                            count++;
                        }
                    }
                }
            }
            n_mines[i][j]=count;
        }
        else{n_mines[i][j]=-1;}

    }
}

}


void Game::get_location()
{
    row=x/70;
    column=y/70;
}

int Game::check_win()
{
    int i,j,count=0;
    for(i=0;i<nr;i++)
    {
        for(j=0;j<nc;j++)
        {   if((flag[i][j]==1)&&(a[i][j]==0)) {return 0;}
            if(a[i][j]==1)
            {
                if(flag[i][j]==1)
                {
                    count++;
                }
            }
        }
    }
   if(count==n) return 1;
    for(i=0;i<nr;i++)
    {
        for(j=0;j<nc;j++)
        {
            if(a[i][j]==0)
            {
                if(print[i][j]!=1)
                {
                    return 0;
                }
            }
        }
    }

    return 1;

}


void Game::processEvents()
{
sf::Event event;
while (mWindow.pollEvent(event))
{
switch (event.type)
{
case sf::Event::MouseButtonPressed: if (event.mouseButton.button == sf::Mouse::Left)
                                    {
                                        x=event.mouseButton.x;
                                        y=event.mouseButton.y;
                                        get_location();
                                        check=uncover();
                                        check1=check_win();
                                        return ;

                                    }

                                    if (event.mouseButton.button == sf::Mouse::Right)
                                    {
                                        x=event.mouseButton.x;
                                        y=event.mouseButton.y;
                                        get_location();
                                        if (flag[row][column]==0)
                                        {
                                            flagit();
                                            check1=check_win();
                                            return ;
                                        }
                                        if (flag[row][column]==1)
                                        {
                                            unflagit();
                                            check1=check_win();
                                            return ;
                                        }

                                    }


case sf::Event::MouseButtonReleased: return;


case sf::Event::Closed:
                          mWindow.close();
                          return ;
}
}
}

void Game::render()
{  float xpos,ypos;int i,j;
   if (check1==1)
   {
            for(i=0; i<nr; i++)
            {
                for(j=0; j<nc; j++)
                {   xpos=70*i;ypos=70*j;

                    if(flag[i][j]==1)
                    {
                        sf::Texture texture;
                        texture.loadFromFile("minesweeper/flag.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(xpos,ypos);
                        mWindow.draw(sprite);
                        continue;
                    }
                    if((print[i][j]==1)&&(a[i][j]==0))
                    {
                        if(n_mines[i][j]==0)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/0.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==1)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/1.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==2)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/2.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==3)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/3.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==4)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/4.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==5)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/5.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==6)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/6.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==7)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/7.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==8)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/8.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                    }

                    if(print[i][j]==0)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/blank.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                }

            }
        mWindow.display();
        sf::SoundBuffer buffer;
        buffer.loadFromFile("minesweeper/victory.wav");
        sf::Sound sound;
        sound.setBuffer(buffer);
        sound.play();
       for(i=0;i<1000000;i++)
       {

           for(j=0;j<1200;j++)
            {

            }
       }
       mWindow.close();
       mWindow.create(sf::VideoMode(508,508), "MINESWEEPER - YOU WON!!!");
       sf::Texture texture;
       texture.loadFromFile("minesweeper/won.png");
       sf::Sprite sprite(texture);
       mWindow.draw(sprite);
       mWindow.display();
       for(i=0;i<1000000;i++)
       {

           for(j=0;j<1200;j++)
            {

            }
       }
       mWindow.close();
       cout<<"\n\nYou won the game! ";
       return;
   }

   if (check==1)
   {
            for(int i=0; i<nr; i++)
            {
                for(int j=0; j<nc; j++)
                {   xpos=70*i;ypos=70*j;

                    if(flag[i][j]==1)
                    {
                        sf::Texture texture;
                        texture.loadFromFile("minesweeper/flag.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(xpos,ypos);
                        mWindow.draw(sprite);
                        continue;
                    }
                    if((print[i][j]==1)&&(a[i][j]==0))
                    {
                        if(n_mines[i][j]==0)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/0.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==1)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/1.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==2)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/2.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==3)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/3.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==4)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/4.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==5)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/5.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==6)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/6.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==7)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/7.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==8)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/8.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                    }

                    if(print[i][j]==0)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/blank.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                }

            }

        mWindow.display();
}

 if (check==-1)
   {  mWindow.clear();
      for(int i=0; i<nr; i++)
            {
                for(int j=0; j<nc; j++)
                {   xpos=70*i;ypos=70*j;
                    if((print[i][j]==1)&&(a[i][j]==0))
                    {
                        if(n_mines[i][j]==0)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/0.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==1)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/1.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==2)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/2.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==3)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/3.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==4)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/4.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==5)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/5.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==6)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/6.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==7)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/7.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

                        if(n_mines[i][j]==8)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/8.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }
                    }
                    if((a[i][j]==1))
                    {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/mine.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                    }

                    if(print[i][j]==0 && a[i][j]==0)
                        {
                           sf::Texture texture;
                           texture.loadFromFile("minesweeper/blank.png");
                           sf::Sprite sprite(texture);
                           sprite.setPosition(xpos,ypos);
                           mWindow.draw(sprite);
                           continue;
                        }

              }
            }
     mWindow.display();
     sf::SoundBuffer buffer;
     buffer.loadFromFile("minesweeper/explosion.wav");
     sf::Sound sound;
     sound.setBuffer(buffer);
     sound.play();
     for(int i=0;i<1000000;i++)
     {

       for(int j=0;j<1200;j++)
       {

       }
     }
       mWindow.close();
       mWindow.create(sf::VideoMode(508,508), "MINESWEEPER - YOU LOST!!!");
       sf::Texture texture;
       texture.loadFromFile("minesweeper/lost.png");
       sf::Sprite sprite(texture);
       mWindow.draw(sprite);
       mWindow.display();
       int i,j;
       for(i=0;i<1000000;i++)
       {

           for(j=0;j<1200;j++)
            {

            }
       }
       mWindow.close();
       cout<<"\n\nYou lost the game! ";
       return;

   }
}

void Game::run()
{
switch(n)
{
    case 4: mWindow.create(sf::VideoMode(70*nr, 70*nc), "MINESWEEPER - Beginner level - 4 MINES"); break;

    case 9: mWindow.create(sf::VideoMode(70*nr, 70*nc), "MINESWEEPER - Intermediate level - 9 MINES"); break;

    case 15: mWindow.create(sf::VideoMode(70*nr, 70*nc), "MINESWEEPER - Advanced level - 15 MINES"); break;

}
while (mWindow.isOpen())
{
processEvents();
render();
}
if(check1==1)
{
    if(n==4)  bet = bet*2;
    if(n==9) bet=bet*3;
    if(n==15) bet=bet*4;
    deposit_win(bet,ac.retacno());
    cout<<"Your account is credited with "<<bet<<" points!!\n\n";
}
if(check1==0)
{
    cout<<bet<<" points have been deducted from your account!! "<<"\n\n";

}
}

//************************************************************************************************************
//************************************************************************************************************
//CODE FOR MINESWEEPER GAME ENDS HERE..
//*************************************************************************************************************
//**************************************************************************************************************
//CODE FOR 7 UP 7 DOWN GAME BEGINS..
//*************************************************************************************************************
//**************************************************************************************************************

class Game1
{
    private:
    int i,j,x,m,check,check7,bet; account ac;
    void process();
    void render1();
public:
    Game1(account a)
    {
        check=-1; ac=a;
    }
    void run1();
    private:
        sf::RenderWindow mWindow;
};
void Game1::process()
{
    sf::Event event;
while (mWindow.pollEvent(event))
{
switch (event.type)
{
case sf::Event::MouseButtonPressed:
{
     x=event.mouseButton.x;

     x=x/284;

     srand(time(0));
     i=(rand()%6)+1;
          j=(rand()%6)+1;

          if((i+j)>7)
          {
              m=2;
          }
          if((i+j)==7)
          {
              m=1;
          }if((i+j)<7)
          {
              m=0;
          }
     if(x==m)
     {if((i+j)==7)
     {
         check7=1;
     }
     else{check7=0;}
         check=1;
     }
     else{check=0;}
     return ;
}
case sf::Event::MouseButtonReleased: return;


case sf::Event::Closed:   mWindow.close();
                          return ;
}
}
}
void Game1::render1()
{
    if(check==-1)
    {
       sf::Texture texture;
                        texture.loadFromFile("7up_down/fcasino.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);
         mWindow.display();

    }
    if (check==0)
    {mWindow.close();
     mWindow.create(sf::VideoMode(580, 250), "dice");

         if(i==1){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/1.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(i==2){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/2.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(i==3){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/3.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(i==4){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/4.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(i==5){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/5.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(i==6){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/6.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(j==1){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/1.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    if(j==2){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/2.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    if(j==3){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/3.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    if(j==4){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/4.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    if(j==5){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/5.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    if(j==6){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/6.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    mWindow.display();sf::SoundBuffer buffer;
        buffer.loadFromFile("7up_down/dice.wav");
        sf::Sound sound;
        sound.setBuffer(buffer);
        sound.play();
     for(i=0;i<100000;i++)
       {

           for(j=0;j<4000;j++)
            {

            }
       }
       mWindow.close();

                  mWindow.create(sf::VideoMode(450,350), "loser");
                  sf::Texture texture;
                        texture.loadFromFile("7up_down/loser.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);
                    mWindow.display();
                    sf::SoundBuffer buffer1;
        buffer1.loadFromFile("7up_down/loser.wav");
        sf::Sound sound1;
        sound1.setBuffer(buffer1);
        sound1.play();
                      for(i=0;i<100000;i++)
       {

           for(j=0;j<14000;j++)
            {

            }
       }
       mWindow.close();
                   }
    if(check==1)
    {mWindow.close();
     mWindow.create(sf::VideoMode(580, 250), "dice");

           if(i==1){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/1.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(i==2){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/2.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(i==3){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/3.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(i==4){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/4.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(i==5){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/5.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(i==6){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/6.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);

                    }
                    if(j==1){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/1.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    if(j==2){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/2.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    if(j==3){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/3.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    if(j==4){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/4.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    if(j==5){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/5.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    if(j==6){
         sf::Texture texture;
                        texture.loadFromFile("7up_down/6.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(290,0);
                        mWindow.draw(sprite);

                    }
                    mWindow.display();
                    sf::SoundBuffer buffer2;
        buffer2.loadFromFile("7up_down/dice.wav");
        sf::Sound sound2;
        sound2.setBuffer(buffer2);
        sound2.play();
     for(i=0;i<100000;i++)
       {

           for(j=0;j<6000;j++)
            {

            }
       }
       mWindow.close();

                  mWindow.create(sf::VideoMode(508,508), "won");
                  sf::Texture texture;
                        texture.loadFromFile("7up_down/won.png");
                        sf::Sprite sprite(texture);
                        sprite.setPosition(0,0);
                        mWindow.draw(sprite);
                    mWindow.display();
                    sf::SoundBuffer buffer3;
        buffer3.loadFromFile("7up_down/victory.wav");
        sf::Sound sound3;
        sound3.setBuffer(buffer3);
        sound3.play();
                      for(i=0;i<100000;i++)
       {

           for(j=0;j<7000;j++)
            {

            }
       }
       mWindow.close();


    }
return ;
}
void Game1::run1()
{   bet=withdraw(ac.retacno());
    if(bet<0) return;
    mWindow.create(sf::VideoMode(850, 550), "GAME:7 Up 7 Down");
while (mWindow.isOpen())
{
process();
render1();
}
if(check==0)
        {
            cout<<"\n\nYou lost! "<<bet<<" points deducted from your account!!\n\n" ;
        }
if(check==1)
        {
            if(check7==1)
            {
                bet=bet*3;
                deposit_win(bet,ac.retacno());
                cout<<"\n\nYou won! Your account is credited with "<<bet<<" points!!\n\n";

            }
            else
            {
                bet=bet*2;
                deposit_win(bet,ac.retacno());
                cout<<"\n\nYou won! Your account is credited with "<<bet<<" points!!\n\n";
            }
        }

return ;
}

//*************************************************************************************************************
//**************************************************************************************************************
//CODE FOR 7 UP 7 DOWN ENDS..
//*************************************************************************************************************
//**************************************************************************************************************
//CODE FOR SUDOKU BEGINS

#include<iostream>
using namespace std;
int grid(int i,int j)
{
    if((i>=0)&&(2>=i)&&(j>=0)&&(2>=j))
    {
        return 1;
    }
    if((i>=0)&&(2>=i)&&(j>=3)&&(5>=j))
    {
        return 2;
    }if((i>=0)&&(2>=i)&&(j>=6)&&(8>=j))
    {
        return 3;
    }if((i>=3)&&(5>=i)&&(j>=0)&&(2>=j))
    {
        return 4;
    }if((i>=3)&&(5>=i)&&(j>=3)&&(5>=j))
    {
        return 5;
    }if((i>=3)&&(5>=i)&&(6>=0)&&(8>=j))
    {
        return 6;
    }if((i>=6)&&(8>=i)&&(j>=0)&&(2>=j))
    {
        return 7;
    }if((i>=6)&&(8>=i)&&(j>=3)&&(5>=j))
    {
        return 8;
    }if((i>=6)&&(8>=i)&&(j>=6)&&(8>=j))
    {
        return 9;
    }
}
/*int grid(int i,int j)
{
     if((i>=0)&&(1>=i)&&(j>=0)&&(1>=j))
    {
        return 1;
    }
    if((i>=0)&&(1>=i)&&(j>=2)&&(3>=j))
    {
        return 2;
    }if((i>=2)&&(3>=i)&&(j>=0)&&(1>=j))
    {
        return 3;
    }if((i>=2)&&(3>=i)&&(j>=2)&&(3>=j))
    {
        return 4;
    }
}*/
int validate(int val,int b[][9],int i,int j)
{int m,n;
    int u,v;
    for(u=0;u<9;u++)
    {
        if(u!=i)
        {
            if(val==b[u][j]){return -1;}
        }
    }
    for(v=0;v<9;v++)
    {
        if(v!=j)
        {
            if(val==b[i][v]){return -2;}
        }
    }
    if(grid(i,j)==1)
        {
        for(u=0;u<3;u++)
        {
            for(v=0;v<3;v++)
            {
                if((u==i)&&(v==j)){}
                else{
                    if(b[u][v]==val){return -3;}

                }
            }
        }
    }
     if(grid(i,j)==2){for(u=0;u<3;u++)
        {
            for(v=3;v<6;v++)
            {
                if((u==i)&&(v==j)){}
                else{
                    if(b[u][v]==val){return -3;}

                }
            }
        }}
      if(grid(i,j)==3){


        for(u=0;u<3;u++)
        {
            for(v=6;v<9;v++)
            {
                if((u==i)&&(v==j)){}
                else{
                    if(b[u][v]==val){return -3;}

                }
            }
        }
      }
       if(grid(i,j)==4){


        for(u=3;u<6;u++)
        {
            for(v=0;v<3;v++)
            {
                if((u==i)&&(v==j)){}
                else{
                    if(b[u][v]==val){return -3;}

                }
            }
        }
       }
       if(grid(i,j)==5){

        for(u=3;u<6;u++)
        {
            for(v=3;v<6;v++)
            {
                if((u==i)&&(v==j)){}
                else{
                    if(b[u][v]==val){return -3;}

                }
            }
        }
       }
       if(grid(i,j)==6){for(u=3;u<6;u++)
        {
            for(v=6;v<9;v++)
            {
                if((u==i)&&(v==j)){}
                else{
                    if(b[u][v]==val){return -3;}

                }
            }
        }}
       if(grid(i,j)==7){


        for(u=6;u<9;u++)
        {
            for(v=0;v<3;v++)
            {
                if((u==i)&&(v==j)){}
                else{
                    if(b[u][v]==val){return -3;}

                }
            }
        }
       }
       if(grid(i,j)==8){

        for(u=6;u<9;u++)
        {
            for(v=3;v<6;v++)
            {
                if((u==i)&&(v==j)){}
                else{
                    if(b[u][v]==val){return -3;}

                }
            }
        }
       }
       if(grid(i,j)==9){


        for(u=6;u<9;u++)
        {
            for(v=6;v<9;v++)
            {
                if((u==i)&&(v==j)){}
                else{
                    if(b[u][v]==val){return -3;}

                }
            }
        }
       }
       /*if((b[u][v]==val)&&(u!=i)&&(j!=v)){return -1;}
       u++;
       if((b[u][v]==val)&&(u!=i)&&(j!=v)){return -1;}
       u--;v++;
       if((b[u][v]==val)&&(u!=i)&&(j!=v)){return -1;}
       u++;
       if((b[u][v]==val)&&(u!=i)&&(j!=v)){return -1;}*/


       return 1;
}
void func(int a[][9],int b[][9],int i,int j,int val,int &check)
{int p,q;if (check==1){return ;}
if((i<0)||(i>8)||(j<0)||(j>8)){return ;}
/*cout<<"i is"<<i<<"   j is"<<j<<"   a is"<<a[i][j]<<"   b is"<<b[i][j]<<"   val is"<<val<<endl;
for(p=0;p<9;p++)
{cout<<endl;
    for(q=0;q<9;q++)
    {
        cout<<b[p][q];
    }
}*/
    if(val==1)
    {
        if(a[i][j]!=0)
        {
            if(j!=8)
            {
                 func(a,b,i,j+1,1,check);
                 return ;
            }
            else
                {
                if(i!=8)
                {
                     func(a,b,i+1,0,1,check);
                     return ;
                }
                else
                {     check=1;
                    for(p=0;p<9;p++)
                    {cout<<endl;
                        for(q=0;q<9;q++)
                        {
                            cout<<b[p][q]<<" ";
                        }
                    }
                    return ;
                }
                }
        }
        else
        {
            int c;
            for(p=1;p<10;p++)
            {
                c=validate(p,b,i,j);
                if(c==1)
                {
                    b[i][j]=p;
            if(j!=8)
            {
                 func(a,b,i,j+1,1,check);
                 return ;
            }
            else
                {
                if(i!=8)
                {
                    func(a,b,i+1,0,1,check);
                    return ;
                }
                else
                {cout<<"solution found";check=1;
                    for(p=0;p<9;p++)
                    {cout<<endl;
                        for(q=0;q<9;q++)
                        {
                            cout<<b[p][q]<<" ";
                        }
                    }
                    return ;
                }
                }

                }
            }
        if(j!=0)
        {    b[i][j]=0;
             func(a,b,i,j-1,-1,check);
             return ;
        }
        else
        {
            if(i!=0)
            {b[i][j]=0;
                 func(a,b,i-1,8,-1,check);
                 return ;
            }
            else
            {b[i][j]=0;
                cout<<"no solution"<<endl;
            }

        }

        }

    }
    else
    {
        if(a[i][j]!=0)
        {
          if(j!=0)
        {
             func(a,b,i,j-1,-1,check);
             return ;
        }
        else
        {
            if(i!=0)
            {
                 func(a,b,i-1,8,-1,check);
                 return ;
            }
            else
            {
                cout<<"no solution1"<<endl;
            }

        }
        }
        else
        {
            int temp,k;

            temp=b[i][j]+1;
            for(;temp<=9;temp++)
            {
                k=validate(temp,b,i,j);
                if(k==1)
                {
                    b[i][j]=temp;
            if(j!=8)
            {
                 func(a,b,i,j+1,1,check);
                 return ;
            }
            else
                {
                if(i!=8)
                {
                     func(a,b,i+1,0,1,check);
                     return ;
                }
                else
                {cout<<"solution found";check=1;
                    for(p=0;p<9;p++)
                    {cout<<endl;
                        for(q=0;q<9;q++)
                        {
                            cout<<b[p][q]<<" ";
                        }
                    }
                    return ;
                }
                }

                }

            }

             if(j!=0)
        {    b[i][j]=0;
             func(a,b,i,j-1,-1,check);
             return ;
        }
        else
        {
            if(i!=0)
            {b[i][j]=0;
                 func(a,b,i-1,8,-1,check);
                 return ;
            }
            else
            {b[i][j]=0;
                cout<<"no solution2"<<endl;
            }

        }
        }
    }
}
int sudoku_main(account ac)
{
int x,y,i,j,k,check=0;
int a[9][9];int b[9][9];

deposit_win(-1000,ac.retacno());

cout<<"\n\n1000 points have been withdrawn from your account!";

cout<<"\n\nWelcome to sudoku auto solver program. Please enter the sudoku puzzle carefully. Blank spaces must be represented by 0.\n\n";

for(x=0;x<9;x++)
{
    for(y=0;y<9;y++)
    {
        a[x][y]=0;
        b[x][y]=0;
    }
}

for(x=0;x<9;x++)
{
    for(y=0;y<9;y++)
    {cin>>a[x][y];
    if((a[x][y]<0)||(a[x][y]>9))
        {cout<<"\n\nInvalid input. Some number is not in between 1 and 9!!";
        return 0;
        }
       b[x][y]=a[x][y];
    }
}
for(x=0,i=0;x<9;x++)
{
    for(y=0;y<9;y++)
    {if(a[x][y]!=0)
    {
        i=validate(a[x][y],b,x,y);
        if(i!=1){
                cout<<"\n\nInvalid input!! ";
            return 0;
        }
        }
    }
}


func(a,b,0,0,1,check);

return 1;
}


int main()
{
int r,c,i,j,k,num,acno,choice,choice1;
string pass ="";char ch;
bool found=false;
account ac;
do
{

cout<<"\n1.PLAYER LOGIN";
cout<<"\n2.ADMIN LOGIN";
cout<<"\n3.EXIT";
cout<<"\nEnter your choice(1-3): " ;
cin>> choice;
if(choice==1)
  {
            cout<<"\nEnter account number: ";
            cin>>acno;
            char password[20];
            cout<<"\nEnter password: ";
            cin>>password;
            ifstream file;
            file.open("account.dat",ios::binary|ios::in);
            file.seekg(0,ios::beg);
            if(!file)
            {
		      cout<<"No record of accounts exist..."; break;
            }
            while(!file.eof() && found==false)
	        {
		    file.read((char* )&ac, sizeof(account));
		    if(ac.retacno()==acno)
            {
                  if(ac.checkpass(password)==1)
			      {ac.show_account();
			      cout<<"\n\nPLAYER login successful!!"<<endl;
			       found=true;
			      }
		       }
            }
            file.close();
            if(found==false){cout<<"\nIncorrect account number or password!!Login failed";}

            if(found==true)
            while(true){
            {found = false;
            cout<<"\n\n\t01.Play minesweeper";
            cout<<"\n\n\t02.Play 7 up 7 down";
            cout<<"\n\n\t03.Sudoku puzzle Autosolve";
            cout<<"\n\n\t04.View account";
            cout<<"\n\n\t05.Modify account password";
            cout<<"\n\n\t06.Logout";
            cout<<"\n\n\tEnter your choice: ";
            cin>>choice1;
            if(choice1==1)
            {
                Game game(ac);
                if(game.init_level()==-1) continue;
                game.init_array();
                game.run();
            }
            else if(choice1==2)
            {
                Game1 game1(ac);
                game1.run1();
            }
            else if(choice1==3)
            {
                int z;char ch;
                cout<<"\n\nCharge for solving one sudoku puzzle is 1000 points. Are you sure you want to continue??(Enter Y/N): ";
                cin>>ch;
                if(ch=='y'||ch=='Y')
                {
                    z=sudoku_main(ac);
                    if(z==1) cout<<"\n\nPuzzle solved successfully!!";
                    else
                    {
                        deposit_win(1000,ac.retacno());
                        cout<<"\n\nPuzzle could not be solved!!";
                        cout<<"\n\n1000 points credited back in your account!";

                    }

                }
                else continue;

            }
            else if(choice1==4) display_sp(ac.retacno());
			else if(choice1==5) modify_account_pass(ac.retacno());
			else if(choice1==6){cout<<"\n\nPlayer logged out successfully!!\n\n"; break;}
            else cout<<"\nWrong choice!";
            }}
  }
    else if(choice == 2)
      {
            cout<<"\nEnter password: ";
            cin>>pass;
            if(pass=="arcade")
            {   cout<<"\n\nAdmin login successful!!";
                do
                {
		        cout<<"\n\n\n\tMAIN MENU";
		        cout<<"\n\n\t01. NEW ACCOUNT";
		        cout<<"\n\n\t02. DEPOSIT AMOUNT";
		        cout<<"\n\n\t03. BALANCE ENQUIRY";
	  	        cout<<"\n\n\t04. ALL ACCOUNT HOLDER LIST";
		        cout<<"\n\n\t05. CLOSE AN ACCOUNT";
		        cout<<"\n\n\t06. MODIFY AN ACCOUNT DETAILS";
		        cout<<"\n\n\t07. EXIT TO LOGIN MENU BY LOGGING OUT";
		        cout<<"\n\n\tSelect Your Option (1-7): ";
		        cin>>choice1;
		        switch(choice1)
		        {
                      case 1:    write_account();
                                   break;
                      case 2:    cout<<"\n\n\tEnter The account No. : "; cin>>num;
                                   deposit(num);
                                   break;
				      case 3:    cout<<"\n\n\tEnter The account No. : "; cin>>num;
                                   display_sp(num);
                                   break;
		              case 4:    display_all();
			                       break;
                      case 5:    cout<<"\n\n\tEnter The account No. : "; cin>>num;
			                       delete_account(num);
                                   break;
		              case 6:    cout<<"\n\n\tEnter The account No. : "; cin>>num;
                                   modify_account(num);
                                   break;
		              case 7:    cout<<"\n\n\tAdmin successfully logged out of the system!!\n\n";
			                       break;
                      default :    cout<<"Wrong choice!Try again";break;
		         }
                }while(choice1!=7);
               }
               else cout<<"\nAdmin login unsuccessful!!";
      }
     else if(choice==3)
     return 0;

     else cout<<"\nWrong choice outer if else!! Try again";

 }while(choice!=3);
}






